



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Cocos2d-x SpriteFrameCache的使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Cocos2d-x SpriteFrameCache的使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 23:26:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>根据官方文档与其他c++属性实现的类似书中示例：</p>
<p><img referrerpolicy="no-referrer"src="http://images0.cnblogs.com/blog2015/602517/201506/032138190234557.png" /></p>
<p>图中的小人是会动的。</p>
<p>首先使用texturepacker制作出一张拼图，导出plist等文件：</p>
<p><img referrerpolicy="no-referrer"src="http://images0.cnblogs.com/blog2015/602517/201506/032140201643432.png" /></p>
<p>plist类似：</p>
<p><img referrerpolicy="no-referrer"src="http://images0.cnblogs.com/blog2015/602517/201506/032141069922239.png" /></p>
<p>3.x的cocos似乎不再鼓励使用什么BatchNode等优化方式，官方支持的是SpriteFrameCache，类似TextureCache。</p>
<p>使用的方式是在某个位置加载plist文件，然后直接通过getSpriteFrameByName就可以获取SpriteFrame。</p>
<p>核心代码：</p>
<div>
<pre class="prettyprint linenums"> bool SpriteScene::init(){
     if (!Layer::init()){
         return false;
     }
     auto visibleSize = Director::getInstance()-&gt;getVisibleSize();

     /*可以用来取代TextureCache来进行图片预加载*/
     auto spriteCache = SpriteFrameCache::getInstance();
     spriteCache-&gt;addSpriteFramesWithFile("runs.plist");
     Vector&lt;SpriteFrame*&gt; frames;
     std::ostringstream osr;
     ; i &lt;= ; ++i){
         osr &lt;&lt; "run" &lt;&lt; i &lt;&lt; ".png";
         frames.pushBack(spriteCache-&gt;getSpriteFrameByName(osr.str()));
         osr.str("");
     }
     auto animation = Animation::createWithSpriteFrames(frames, 0.1f);
     auto animate = Animate::create(animation);

     auto sprite = Sprite::createWithSpriteFrame(spriteCache-&gt;getSpriteFrameByName("run1.png"));
     sprite-&gt;setPosition(Point(visibleSize.width / , visibleSize.height / ));
     this-&gt;addChild(sprite);
     sprite-&gt;runAction(RepeatForever::create(animate));

     return true;
 }</pre>
</div>
<p>ostringstream是我用来实现string格式化的一个方式，这个流的置空大部分文章都认为是str("")这个函数。同时注意不要给流后加上std::endl;</p>
<p>以上。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qydzegq.html">js学习篇--数组按升序降序排列</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96p22n8.html">pwnable&period;kr的passcode</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96z22jq.html">泛函编程（29）－泛函实用结构：Trampoline-不再怕StackOverflow</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oppdpq.html">CSS3实现动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0dd0q.html">0523 Scrum 项目6&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96eyp3q.html">Spring MVC&plus;Quartz 定时任务持久化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd51ed8.html">黄聪：C&num;解析HTML DOM解析类 HtmlParser&period;Net  下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xy6yv8.html">HTML左边和右边是固定的宽度但是中间是自动的布局方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0rom4q.html">Earth to developers&colon; Grow up&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd2k738.html">ubuntu设置系统时间与网络时间同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnor1oq.html">asp&period;net core &plus; angular2 的环境配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwx0w8.html">第五天学习内容   for循环，嵌套</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yd0608.html">angular实现跨域</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ykxrn8.html">C&num; 获取当前方法的名称空间、类名和方法名称</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljgeve9.html">&lbrack;Swift&rsqb;LeetCode385&period; 迷你语法分析器 &vert; Mini Parser</a>
		</li>
						<li><a href="https://www.batexi.com/a/9506p268.html">Python&mdash;&mdash;爬虫&mdash;&mdash;爬虫的原理与数据抓取</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gg436q.html">&period;net 后台判断是否要替换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r50ymeq.html">【进阶1-5期】JavaScript深入之4类常见内存泄漏及如何避免&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4x1zx9.html">从零开始学 Web 之 移动Web（七）Bootstrap</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyn1ldq.html">Map的知识点梳理（不包含collections工具类）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8zwjzx8.html">netstat&lpar;转载&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k7vej9.html">支付宝Wap支付你了解多少？</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93zvegq.html">windows &amp;amp&semi; mac 安装lua</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq134v58.html">奇怪吸引子---WimolBanlue</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q24yw38.html">android 常用类</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k7rk79.html">fastreport totalpage 只有设置doublepassreport为true 才正确否则为0</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7rj0x8.html">ecshop退出登录会清空购物车的bug优化，最完美解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j3xxgq.html">转&colon;Android开发之旅：环境搭建及HelloWorld</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qykxdg9.html">高效开发Android App的10个建议</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93zkdzq.html">ASP&period;NET 回调技术&lpar;CallBack&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
